/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
define("vs/languages/html/common/htmlTags",["require","exports","vs/base/common/strings","vs/base/common/arrays"],function(e,t,n,r){function o(e){return-1!==r.binarySearch(a,e,function(e,t){return e.localeCompare(t)})}function i(){var e=[],t={html:["manifest"],head:e,title:e,noscript:e,section:e,nav:e,article:e,aside:e,h1:e,h2:e,h3:e,h4:e,h5:e,h6:e,hgroup:e,header:e,footer:e,address:e,p:e,hr:e,pre:e,blockquote:["cite"],ol:["reversed:v","start"],ul:e,li:["value"],dl:e,dt:e,dd:e,figure:e,figcaption:e,div:e,a:["href","target","ping","rel","media","hreflang","type"],em:e,strong:e,small:e,s:e,cite:e,q:["cite"],dfn:e,abbr:e,data:["value"],time:["datetime","pubdate"],code:e,var:e,samp:e,kbd:e,sub:e,sup:e,i:e,b:e,u:e,mark:e,ruby:e,rt:e,rp:e,bdi:e,bdo:e,span:e,br:e,wbr:e,ins:["cite","datetime"],del:["cite","datetime"],img:["alt","src","srcset","crossorigin:xo","usemap","ismap:v","width","height"],iframe:["src","srcdoc","name","sandbox","seamless","width","height"],embed:["src","type","width","height"],object:["data","type","typemustmatch:v","name","usemap","form","width","height"],param:["name","value"],video:["src","crossorigin:xo","poster","preload","autoplay:v","mediagroup","loop:v","muted:v","controls:v","width","height"],audio:["src","crossorigin:xo","preload","autoplay:v","mediagroup","loop:v","muted:v","controls:v"],source:["src","type","media"],track:["default:v","kind","label","src","srclang"],canvas:["width","height"],map:["name"],area:["alt","coords","shape","href","target","ping","rel","media","hreflang","type"],base:["href","target"],link:["href","rel","media","hreflang","type","sizes"],meta:["name","http-equiv","content","charset"],style:["media","type","scoped:v"],script:["src","async:v","defer:v","type","charset"],body:["onafterprint","onbeforeprint","onbeforeunload","onblur","onerror","onfocus","onhashchange","onload","onmessage","onoffline","ononline","onpagehide","onpageshow","onpopstate","onresize","onscroll","onstorage","onunload"],table:e,caption:e,colgroup:["span"],col:["span"],tbody:e,thead:e,tfoot:e,tr:e,td:["colspan","rowspan","headers"],th:["colspan","rowspan","headers","scope","abbr"],form:["accept-charset","action","autocomplete:o","enctype","method:m","name","novalidate:v","target"],fieldset:["disabled:v","form","name"],legend:e,label:["form","for"],input:["accept","alt","autocomplete:o","autofocus:v","checked:v","dirname","disabled:v","form","formaction","formenctype","formmethod:m","formnovalidate:v","formtarget","height","inputmode","list","max","maxlength","min","multiple:v","name","pattern","placeholder","readonly:v","required","size","src","step","type:t","value","width"],button:["autofocus:v","disabled:v","form","formaction","formenctype","formmethod:m","formnovalidate:v","formtarget","name","type:bt","value"],select:["autofocus:v","disabled:v","form","multiple:v","name","required:v","size"],datalist:["option"],optgroup:["disabled:v","label"],option:["disabled:v","label","selected:v","value"],textarea:["autocomplete:o","autofocus:v","cols","dirname","disabled:v","form","inputmode","maxlength","name","placeholder","readonly:v","required:v","rows","wrap"],keygen:["autofocus:v","challenge","disabled:v","form","keytype","name"],output:["for","form","name"],progress:["value","max"],meter:["value","min","max","low","high","optimum"],details:["open:v"],summary:e,command:["type","label","icon","disabled:v","checked:v","radiogroup","command"],menu:["type","label"],dialog:["open:v"]},r=["accesskey","class","contenteditable:b","contextmenu","dir:d","draggable:a","dropzone","hidden:v","id","inert:v","itemid","itemprop","itemref","itemscope:v","itemtype","lang","role","spellcheck:b","style","tabindex","title","translate"],o=["onabort","onblur","oncanplay","oncanplaythrough","onchange","onclick","oncontextmenu","ondblclick","ondrag","ondragend","ondragenter","ondragleave","ondragover","ondragstart","ondrop","ondurationchange","onemptied","onended","onerror","onfocus","onformchange","onforminput","oninput","oninvalid","onkeydown","onkeypress","onkeyup","onload","onloadeddata","onloadedmetadata","onloadstart","onmousedown","onmousemove","onmouseout","onmouseover","onmouseup","onmousewheel","onpause","onplay","onplaying","onprogress","onratechange","onreset","onreadystatechange","onseeked","onseeking","onselect","onshow","onstalled","onsubmit","onsuspend","ontimeupdate","onvolumechange","onwaiting"],i={b:["true","false"],a:["true","false","auto"],d:["ltr","rtl"],m:["get","post"],o:["on","off"],t:["hidden","text","search","tel","url","email","password","datetime","date","month","week","time","datetime-local","number","range","color","checkbox","radio","file","submit","image","reset","button"],bt:["button","submit","reset"],xo:["anonymous","use-credentials"]};return{collectTags:function(e){for(var n in t)e(n)},collectAttributes:function(e,n){if(r.forEach(function(e){var t=e.split(":");n(t[0],t[1])}),o.forEach(function(e){n(e,"event")}),e){var i=t[e];i&&i.forEach(function(e){var t=e.split(":");n(t[0],t[1])})}},collectValues:function(e,o,s){var a=o+":",c=function(e){e.forEach(function(e){if(e.length>a.length&&n.startsWith(e,a)){var t=e.substr(a.length);if("v"===t)s(o);else{var r=i[t];r&&r.forEach(s)}}})},l=t[e];l&&c(l),c(r)}}}function s(){var e={input:["ng-model","ng-required","ng-minlength","ng-maxlength","ng-pattern","ng-trim"],select:["ng-model"],textarea:["ng-model","ng-required","ng-minlength","ng-maxlength","ng-pattern","ng-trim"]},t=["ng-app","ng-bind","ng-bindhtml","ng-bindtemplate","ng-blur","ng-change","ng-checked","ng-class","ng-classeven","ng-classodd","ng-click","ng-cloak","ng-controller","ng-copy","ng-csp","ng-cut","ng-dblclick","ng-disabled","ng-focus","ng-form","ng-hide","ng-href","ng-if","ng-include","ng-init","ng-jq","ng-keydown","ng-keypress","ng-keyup","ng-list","ng-modelOptions","ng-mousedown","ng-mouseenter","ng-mouseleave","ng-mousemove","ng-mouseover","ng-mouseup","ng-nonbindable","ng-open","ng-options","ng-paste","ng-pluralize","ng-readonly","ng-repeat","ng-selected","ng-show","ng-src","ng-srcset","ng-style","ng-submit","ng-switch","ng-transclude","ng-value"];return{collectTags:function(){},collectAttributes:function(n,r){if(n){var o=e[n];o&&o.forEach(function(e){r(e,null),r("data-"+e,null)})}t.forEach(function(e){r(e,null),r("data-"+e,null)})},collectValues:function(){}}}var a=["area","base","basefont","br","col","command","embed","frame","hr","img","input","isindex","keygen","link","meta","param","source","track","wbr"];t.isEmptyElement=o,t.getHTML5TagProvider=i,t.getAngularTagProvider=s});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/languages/html/common/htmlWorker",["require","exports","vs/base/common/winjs.base","vs/editor/common/modes/abstractModeWorker","vs/languages/lib/common/beautify-html","vs/languages/html/common/htmlTags","vs/base/common/network","vs/base/common/strings","vs/editor/common/core/range"],function(e,t,n,r,o,i,s,a,c){function l(e,t){var n=t.column-1,r=t.lineNumber,o=e.getLineTokens(r),i=e.getLineContent(r),s=o.findIndexOfOffset(n),c=o.getTokenCount(),l=o.getTokenType(s),u=o.getTokenStartIndex(s),d=o.getTokenEndIndex(s,i.length);return""!==l&&!a.startsWith(l,"delimiter")||u!==n||(s--,s>=0?(l=o.getTokenType(s),u=o.getTokenStartIndex(s),d=o.getTokenEndIndex(s,i.length)):(l="",u=d=0)),{getTokenType:function(){return l},isTagToken:function(){return a.startsWith(l,h)},isAtTokenEnd:function(){return n===d},isAtTokenStart:function(){return n===u},getTokenContent:function(){return i.substring(u,d)},isOpenBrace:function(){return d>u&&"<"===i.charAt(u)},getTokenPosition:function(){return{lineNumber:r,column:u+1}},getTokenRange:function(){return{startLineNumber:r,startColumn:u+1,endLineNumber:r,endColumn:d+1}},getModel:function(){return e},scanBack:function(){if(0>=r)return!1;s--;do{for(;s>=0;){if(l=o.getTokenType(s),u=o.getTokenStartIndex(s),d=o.getTokenEndIndex(s,i.length),a.startsWith(l,"delimiter")||a.startsWith(l,"tag")||a.startsWith(l,"attribute"))return!0;s--}r--,r>0&&(o=e.getLineTokens(r),i=e.getLineContent(r),c=o.getTokenCount(),s=c-1)}while(r>0);return o=null,l=i="",u=d=c=0,!1},scanForward:function(){if(r>e.getLineCount())return!1;s++;do{for(;c>s;){if(l=o.getTokenType(s),u=o.getTokenStartIndex(s),d=o.getTokenEndIndex(s,i.length),a.startsWith(l,"delimiter")||a.startsWith(l,"tag")||a.startsWith(l,"attribute"))return!0;s++}r++,s=0,r<=e.getLineCount()&&(o=e.getLineTokens(r),i=e.getLineContent(r),c=o.getTokenCount())}while(r<=e.getLineCount());return l=i="",u=d=c=0,!1}}}function u(e){return/^\s*$/.test(e)}var d;!function(e){e[e.LOOKING_FOR_HREF_OR_SRC=1]="LOOKING_FOR_HREF_OR_SRC",e[e.AFTER_HREF_OR_SRC=2]="AFTER_HREF_OR_SRC"}(d||(d={}));var h="tag.html.tag-",p=function(e){function t(t,n,r){e.call(this,t,n,r),this._contextService=t.contextService,this._tagProviders=[],this._tagProviders.push(i.getHTML5TagProvider()),this.addCustomTagProviders(this._tagProviders)}return __extends(t,e),t.prototype.addCustomTagProviders=function(e){e.push(i.getAngularTagProvider())},t.prototype.format=function(e,t,r){var i=this.resourceService.get(e),s=t?i.getValueInRange(t):i.getValue(),a=o.html_beautify(s,{indent_size:r.insertSpaces?r.tabSize:1,indent_char:r.insertSpaces?" ":"	",wrap_line_length:120});return n.TPromise.as([{range:t,text:a}])},t.prototype.findMatchingOpenTag=function(e){for(var t={},n=!1;e.scanBack();)if(e.isTagToken()&&!n){var r=e.getTokenContent();if(e.scanBack(),"delimiter.end.html"===e.getTokenType())t[r]=(t[r]||0)+1;else if(!i.isEmptyElement(r)){if(!t[r])return r;t[r]--}}else"delimiter.start.html"===e.getTokenType()&&(n="/>"===e.getTokenContent());return null},t.prototype.collectTagSuggestions=function(e,t,n){var r=this,o=e.getModel(),i=o.getLineContent(t.lineNumber).substr(t.column-1),s=u(i)||a.startsWith(i,"<")?">":"",c=function(i){var a=e.getTokenPosition(),c=r.findMatchingOpenTag(e);if(c){var l={label:"/"+c,codeSnippet:"/"+c+s,type:"property"};if(n.suggestions.push(l),i){var d=e.getTokenPosition();if(a.lineNumber!==d.lineNumber){var h=o.getLineContent(d.lineNumber).substring(0,d.column-1),p=o.getLineContent(a.lineNumber).substring(0,a.column-1);u(h)&&u(p)&&(n.overwriteBefore=t.column-1,l.codeSnippet=h+"</"+c+s)}}return!0}return!1};if("delimiter.end.html"===e.getTokenType()){n.overwriteBefore=n.currentWord.length+1;var l=c(!0);l||(n.overwriteBefore=n.currentWord.length+1,this._tagProviders.forEach(function(e){e.collectTags(function(e){n.suggestions.push({label:"/"+e,codeSnippet:"/"+e+s,type:"property"})})}))}else c(!1),this._tagProviders.forEach(function(e){e.collectTags(function(e){n.suggestions.push({label:e,codeSnippet:e,type:"property"})})})},t.prototype.collectContentSuggestions=function(){},t.prototype.collectAttributeSuggestions=function(e,t){var n=null;do{if(e.isTagToken()){n=e.getTokenContent();break}if("delimiter.start.html"===e.getTokenType())break}while(e.scanBack());this._tagProviders.forEach(function(e){e.collectAttributes(n,function(e,n){var r=e;"v"!==n&&(r+='="{{}}"'),t.suggestions.push({label:e,codeSnippet:r,type:"handler"===n?"function":"value"})})})},t.prototype.collectAttributeValueSuggestions=function(e,t){for(var n="delimiter.assign.html"===e.getTokenType(),r=null,o=null;e.scanBack();)if("attribute.name.html"===e.getTokenType()){r=e.getTokenContent();break}for(;e.scanBack();){if(e.isTagToken()){o=e.getTokenContent();break}if("delimiter.start.html"===e.getTokenType())return}this._tagProviders.forEach(function(e){e.collectValues(o,r,function(e){t.suggestions.push({label:e,codeSnippet:n?'"'+e+'"':e,type:"unit"})})})},t.prototype.doSuggest=function(e,t){var r=this.resourceService.get(e),o=r.getWordUntilPosition(t).word,i={currentWord:o,suggestions:[]},s=l(r,t);switch(s.getTokenType()){case"delimiter.start.html":case"delimiter.end.html":s.isOpenBrace()?this.collectTagSuggestions(s,t,i):this.collectContentSuggestions(i);break;case"attribute.name.html":this.collectAttributeSuggestions(s,i);break;case"attribute.value.html":this.collectAttributeValueSuggestions(s,i);break;case"delimiter.assign.html":s.isAtTokenEnd()&&this.collectAttributeValueSuggestions(s,i);break;case"":if(u(s.getTokenContent())&&s.scanBack())switch(s.getTokenType()){case"attribute.value.html":case"attribute.name.html":this.collectAttributeSuggestions(s,i);break;case"delimiter.assign.html":this.collectAttributeValueSuggestions(s,i);break;case"delimiter.start.html":case"delimiter.end.html":s.isOpenBrace()?this.collectTagSuggestions(s,t,i):this.collectContentSuggestions(i);break;default:s.isTagToken()&&this.collectAttributeSuggestions(s,i)}else this.collectContentSuggestions(i);break;default:s.isTagToken()&&(s.scanBack(),this.collectTagSuggestions(s,t,i))}return n.Promise.as(i)},t.prototype.findMatchingBracket=function(e,t){if(i.isEmptyElement(e))return null;var n=0;if(t.scanBack(),"delimiter.end.html"===t.getTokenType())for(var r=!1;t.scanBack();)if(t.isTagToken()&&t.getTokenContent()===e&&!r){var o=t.getTokenRange();if(t.scanBack(),"delimiter.start.html"===t.getTokenType()){if(0===n)return o;n--}else n++}else"delimiter.start.html"===t.getTokenType()&&(r="/>"===t.getTokenContent());else for(var s=!1;t.scanForward();)if(t.isTagToken()&&t.getTokenContent()===e)if(s){if(n--,0>=n)return t.getTokenRange()}else if(t.scanForward(),"delimiter.start.html"===t.getTokenType()&&"/>"===t.getTokenContent()){if(0>=n)return null}else n++;else"delimiter.start.html"===t.getTokenType()?s=!1:"delimiter.end.html"===t.getTokenType()&&(s=!0);return null},t.prototype.findOccurrences=function(e,t){var r=this.resourceService.get(e),o=r.getWordAtPosition(t),i=o?o.word:"",s=[],a=l(r,t);if(a.isTagToken()){var c=a.getTokenContent();s.push({range:a.getTokenRange()});var u=this.findMatchingBracket(c,a);u&&s.push({range:u})}else for(var d=r.getAllWordsWithRange(),h=Math.min(1e3,d.length),p=0;h>p;p++)d[p].text===i&&s.push({range:d[p].range});return n.TPromise.as(s)},t._stripQuotes=function(e){return e.replace(/^'([^']+)'$/,function(e,t){return t}).replace(/^"([^"]+)"$/,function(e,t){return t})},t._getWorkspaceUrl=function(e,n,r){if(r=t._stripQuotes(r),/^\s*javascript\:/i.test(r)||/^\s*\#/i.test(r))return null;if(/^\s*https?:\/\//i.test(r)||/^\s*file:\/\//i.test(r))return r.replace(/^\s*/g,"");if(/^\s*\/\//i.test(r)){var o=e.getScheme(),i="http";return o===s.schemas.https&&(i=s.schemas.https),i+":"+r.replace(/^\s*/g,"")}var c=e.combine(r).toString();if(n&&e.startsWith(n)){var l=n.toString(),u=a.commonPrefixLength(l,c);return l+c.substr(u)}return c},t.prototype.createLink=function(e,n,r,o,i,s){var a=t._getWorkspaceUrl(e,n,r);return a?{range:{startLineNumber:o,startColumn:i,endLineNumber:o,endColumn:s},url:a}:null},t.prototype._computeHTMLLinks=function(e){var t,n,r,o,i,a,c,l,u,h,p=e.getLineCount(),m=[],f=d.LOOKING_FOR_HREF_OR_SRC,g=e.getAssociatedResource(),v=String(this._contextService.getWorkspace().resource);if("/"===v.charAt(v.length-1))var b=new s.URL(v);else var b=new s.URL(v+"/");for(t=1;p>=t;t++)for(n=e.getLineContent(t),r=n.length,o=e.getLineTokens(t),c=0,a=o.getTokenCount();a>c;c++)switch(i=o.getTokenType(c)){case"delimiter.assign.html":case"":break;case"attribute.name.html":f===d.LOOKING_FOR_HREF_OR_SRC&&(l=o.getTokenEndIndex(c,r),u=n.substring(o.getTokenStartIndex(c),l).toLowerCase(),("src"===u||"href"===u)&&(f=d.AFTER_HREF_OR_SRC));break;case"attribute.value.html":f===d.AFTER_HREF_OR_SRC&&(l=o.getTokenEndIndex(c,r),u=n.substring(o.getTokenStartIndex(c),l),h=this.createLink(g,b,u,t,o.getTokenStartIndex(c)+2,l),h&&m.push(h),f=d.LOOKING_FOR_HREF_OR_SRC);default:0===i.indexOf("tag.html")?f=d.LOOKING_FOR_HREF_OR_SRC:f===d.AFTER_HREF_OR_SRC&&(f=d.LOOKING_FOR_HREF_OR_SRC)}return m},t.prototype.computeLinks=function(t){var n=this;return e.prototype.computeLinks.call(this,t).then(function(e){var r,o,i,s,a,l,u,d=n.resourceService.get(t),h=n._computeHTMLLinks(d),p=[];for(r=0,i=0,o=e.length,s=h.length;o>r&&s>i;)a=e[r],l=h[i],c.Range.areIntersectingOrTouching(a.range,l.range)?r++:(u=c.Range.compareRangesUsingStarts(a.range,l.range),0>u?(p.push(a),r++):(p.push(l),i++));for(;o>r;r++)p.push(e[r]);for(;s>i;i++)p.push(h[i]);return p})},t}(r.AbstractModeWorker);t.HTMLWorker=p});