/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";define("vs/languages/typescript/common/js/shebangRewriter",["require","exports"],function(){var e=function(){function e(){}return Object.defineProperty(e.prototype,"name",{get:function(){return"rewriter.shebang"},enumerable:!0,configurable:!0}),e.prototype.computeEdits=function(t){var n=t.sourceFile.getFullText();if(n.charCodeAt(0)===e._hash&&n.charCodeAt(1)===e._bang){var r=~n.indexOf("\n")||~n.indexOf("\r");r=r?~r:n.length,t.newDelete(0,r)}},e._hash="#".charCodeAt(0),e._bang="!".charCodeAt(0),e}();return e});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/languages/javascript/common/javascriptWorker",["require","exports","vs/base/common/objects","vs/base/common/arrays","vs/base/common/winjs.base","vs/languages/typescript/common/typescriptWorker2","vs/languages/typescript/common/options","vs/languages/typescript/common/js/rewriting","vs/languages/typescript/common/features/suggestions","vs/languages/typescript/common/features/parameterHints","vs/languages/typescript/common/features/occurrences","vs/languages/typescript/common/features/extraInfo","vs/languages/typescript/common/features/references","vs/languages/typescript/common/features/definitions","vs/languages/typescript/common/features/quickFix","vs/languages/typescript/common/features/diagnostics","vs/languages/typescript/common/features/rename","vs/languages/typescript/common/js/shebangRewriter"],function(e,t,n,r,o,i,s,a,c,l,u,d,h,p,m,f,g,v){var b=function(e){function t(t,n,r){var o=this;e.call(this,t,n,r),this._projectService.defaultRewriter=[new v],this._fancyRewriters=[new v],r.forEach(function(e){"function"==typeof e.computeEdits&&o._fancyRewriters.push(e)})}return __extends(t,e),t.prototype._doConfigure=function(t){return e.prototype._doConfigure.call(this,t,s.javaScriptOptions)},t.prototype.doValidateSemantics=function(e){var t=[],r=this._projectService.getProject(e,this._fancyRewriters),o=f.getSemanticDiagnostics(r.languageService,e,this._options);if(o){var i=r.translations.getTranslator(e);return o.markers.forEach(function(e){var r=i.info(e);r.origin?(n.mixin(e,r.origin,!0),t.push(e)):r.isInserted||(n.mixin(e,i.from(e),!0),t.push(e))}),this.markerService.changeOne("/"+this._getMode().getId()+"/semantic",e,t),o.hasMissingFiles}},t.prototype.doSuggest=function(e,t){var n=this._projectService.getProject(e,this._fancyRewriters);t=n.translations.getTranslator(e).to(t);var i=c.computeSuggestions(n.languageService,e,t,this._options);return r.forEach(i.suggestions,function(e,t){a.containsEncodedVariableName(e.label)&&t()}),o.TPromise.as(i)},t.prototype.getSuggestionDetails=function(e,t,n){var r=this._projectService.getProject(e,this._fancyRewriters);t=r.translations.getTranslator(e).to(t);var i=c.getSuggestionDetails(r.languageService,e,t,n,this._options);return i.typeLabel=a.decodeVariableNames(i.typeLabel,r.translations.getOriginal(e)),o.TPromise.as(i)},t.prototype.getParameterHints=function(e,t){var n=this._projectService.getProject(e,this._fancyRewriters);t=n.translations.getTranslator(e).to(t);var r=l.compute(n.languageService,e,t);if(r){for(var i=n.translations.getOriginal(e),s=0,c=r.signatures;s<c.length;s++){var u=c[s];u.label=a.decodeVariableNames(u.label,i);for(var d=0,h=u.parameters;d<h.length;d++){var p=h[d];p.label=a.decodeVariableNames(p.label,i),p.signatureLabelOffset=0,p.signatureLabelEnd=0}}return o.TPromise.as(r)}},t.prototype.findOccurrences=function(e,t,n){var i=this._projectService.getProject(e,this._fancyRewriters),s=i.translations.getTranslator(e);t=s.to(t);var a=u.compute(i.languageService,e,t,n);return r.forEach(a,function(t,n){s.info(t.range).isInserted?n():t.range=i.translations.getTranslator(e).from(t.range)}),o.TPromise.as(a)},t.prototype._findTypeScriptDeclaration=function(e,t){var n=this._projectService.getProject(e,this._fancyRewriters);t=n.translations.getTranslator(e).to(t);var r=p.findDeclaration(n,e,t);if(r){var i=n.translations.getTranslator(r.resourceUrl);if(!i.info(r.range).isInserted)return r.range=i.from(r.range),o.TPromise.as(r)}},t.prototype.findReferences=function(e,t,n){var i=this._projectService.getProject(e,this._fancyRewriters);t=i.translations.getTranslator(e).to(t);var s=h.find(i,e,t,n);return r.forEach(s,function(e,t){var n=i.translations.getTranslator(e.resourceUrl);n.info(e.range).isInserted?t():e.range=n.from(e.range)}),o.TPromise.as(s)},t.prototype.computeInfo=function(e,t){var n=this._projectService.getProject(e,this._fancyRewriters);t=n.translations.getTranslator(e).to(t);var r=d.compute(n.languageService,e,t);return r&&(r.range=n.translations.getTranslator(e).from(r.range),a.decodeVariableNames(r.htmlContent,n.translations.getOriginal(e))),o.TPromise.as(r)},t.prototype.runQuickFixAction=function(e,t,r){var i=this._projectService.getProject(e,this._fancyRewriters),s=i.translations.getTranslator(e).to(t);n.mixin(s,t,!1);var a=m.evaluate(i.languageService,e,s,r);if(a)for(var c=0,l=a.edits;c<l.length;c++){var u=l[c];u.range=i.translations.getTranslator(u.resource).from(u.range)}return o.TPromise.as(a)},t.prototype.getQuickFixes=function(e,t){var r=this._projectService.getProject(e,this._fancyRewriters),i=r.translations.getTranslator(e).to(t);n.mixin(i,t,!1);var s=m.compute(r.languageService,e,i);return o.TPromise.as(s)},t.prototype.rename=function(e,t,n){for(var r=this._projectService.getProject(e,this._fancyRewriters),i=g(r,e,r.translations.getTranslator(e).to(t),n),s=0;s<i.edits.length;s++){var a=i.edits[s],c=r.translations.getTranslator(a.resource),l=c.info(a.range);if(l.isInserted)i.edits.splice(s,1),s-=1;else if(l.isOverlapping){i.edits=[];break}a.range=c.from(a.range)}return o.TPromise.as(i)},t}(i.TypeScriptWorker2);t.JavaScriptWorker=b});