/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";define("vs/languages/typescript/common/features/tokenization",["require","exports","vs/base/common/strings","vs/base/common/arrays","vs/base/common/collections","vs/editor/common/modes","vs/editor/common/modes/supports","vs/languages/vsxml/common/vsxml","vs/editor/common/modes/lineStream","vs/languages/typescript/common/lib/typescriptServices","vs/editor/common/modes/abstractState"],function(e,t,n,r,i,a,o,s,c,l,u){function d(e,t){var n=l.createClassifier(),r=t===f.TypeScript?v:b,i=t===f.TypeScript?_:T;return{shouldGenerateEmbeddedModels:!1,getInitialState:function(){return new g(e,null,t,0,!1)},tokenize:function(e,t,a,o){return p(r,i,n,t,e,a,o)}}}function p(e,t,i,s,c,u){function d(e,t,n){(0===p.tokens.length||void 0!==n||r.tail(p.tokens).type!==t)&&p.tokens.push(new o.Token(e,t,n||a.Bracket.None))}void 0===u&&(u=0);var p={tokens:[],actualStopOffset:u+c.length,endState:new g(s.getMode(),s.getStateData(),s.language,0,!1),modeTransitions:[{startIndex:u,mode:s.getMode()}]};if(0===s.eolState&&h(s,u,c,d))return p;var v=s.language===f.TypeScript;if(!v&&m(s,u,c,d))return p;var _=i.getClassificationsForLine(c,s.eolState,!0),b=0;p.endState.eolState=_.finalLexState,p.endState.inJsDocComment=1===_.finalLexState&&(s.inJsDocComment||/\/\*\*.*$/.test(c));for(var T=0,E=_.entries;T<E.length;T++){var S,k=E[T],C=a.Bracket.None;if(k.classification===l.TokenClass.Punctuation){var x=c.charCodeAt(b);C=y[x]||a.Bracket.None,S=e[x]||t[k.classification],d(b+u,S,C)}else k.classification===l.TokenClass.Comment?p.endState.inJsDocComment||/\/\*\*.*\*\//.test(c.substr(b,k.length))?d(b+u,v?"comment.doc.ts":"comment.doc.js",a.Bracket.None):d(b+u,v?"comment.ts":"comment.js",a.Bracket.None):d(b+u,t[k.classification]||n.empty,void 0);b+=k.length}return p}function m(e,t,n,r){return 0===n.indexOf("#!")?(r(t,"comment.shebang",a.Bracket.None),!0):void 0}function h(e,t,n,r){if(!n.match(E))return!1;var i,o,l=new c.LineStream(n),u=new s.VSXMLExpression(e.getMode(),e);for(l.advanceIfRegExp(E).length>0&&r(t,"comment.vs",a.Bracket.None);!l.eos();){o=l.pos();do{if(i=u.tokenize(l),null===i||void 0===i||(void 0===i.type||null===i.type)&&(void 0===i.nextState||null===i.nextState))throw new Error("Tokenizer must return a valid state");if(i.nextState&&(i.nextState.setStateData(u.getStateData()),u=i.nextState),l.pos()<=o)throw new Error}while(!i.type&&""!==i.type);r(o+t,i.type,i.bracket)}return!0}!function(e){e[e.TypeScript=0]="TypeScript",e[e.EcmaScript5=1]="EcmaScript5"}(t.Language||(t.Language={}));var f=t.Language;t.createTokenizationSupport=d;var g=function(){function e(e,t,n,r,i){this._mode=e,this._state=t,this.language=n,this.eolState=r,this.inJsDocComment=i}return e.prototype.clone=function(){return new e(this._mode,u.AbstractState.safeClone(this._state),this.language,this.eolState,this.inJsDocComment)},e.prototype.equals=function(t){return t===this?!0:t&&t instanceof e?this.eolState!==t.eolState?!1:this.inJsDocComment!==t.inJsDocComment?!1:u.AbstractState.safeEquals(this._state,t._state):!1},e.prototype.getMode=function(){return this._mode},e.prototype.tokenize=function(){throw new Error},e.prototype.getStateData=function(){return this._state},e.prototype.setStateData=function(e){this._state=e},e}(),y=i.createNumberDictionary();y["(".charCodeAt(0)]=a.Bracket.Open,y[")".charCodeAt(0)]=a.Bracket.Close,y["{".charCodeAt(0)]=a.Bracket.Open,y["}".charCodeAt(0)]=a.Bracket.Close,y["[".charCodeAt(0)]=a.Bracket.Open,y["]".charCodeAt(0)]=a.Bracket.Close;var v=i.createNumberDictionary();v["(".charCodeAt(0)]="delimiter.parenthesis.ts",v[")".charCodeAt(0)]="delimiter.parenthesis.ts",v["{".charCodeAt(0)]="delimiter.bracket.ts",v["}".charCodeAt(0)]="delimiter.bracket.ts",v["[".charCodeAt(0)]="delimiter.array.ts",v["]".charCodeAt(0)]="delimiter.array.ts";var _=i.createNumberDictionary();_[l.TokenClass.Identifier]="identifier.ts",_[l.TokenClass.Keyword]="keyword.ts",_[l.TokenClass.Operator]="delimiter.ts",_[l.TokenClass.Punctuation]="delimiter.ts",_[l.TokenClass.NumberLiteral]="number.ts",_[l.TokenClass.RegExpLiteral]="regexp.ts",_[l.TokenClass.StringLiteral]="string.ts";var b=i.createNumberDictionary();b["(".charCodeAt(0)]="delimiter.parenthesis.js",b[")".charCodeAt(0)]="delimiter.parenthesis.js",b["{".charCodeAt(0)]="delimiter.bracket.js",b["}".charCodeAt(0)]="delimiter.bracket.js",b["[".charCodeAt(0)]="delimiter.array.js",b["]".charCodeAt(0)]="delimiter.array.js";var T=i.createNumberDictionary();T[l.TokenClass.Identifier]="identifier.js",T[l.TokenClass.Keyword]="keyword.js",T[l.TokenClass.Operator]="delimiter.js",T[l.TokenClass.Punctuation]="delimiter.js",T[l.TokenClass.NumberLiteral]="number.js",T[l.TokenClass.RegExpLiteral]="regexp.js",T[l.TokenClass.StringLiteral]="string.js";var E=/^\s*\/\/\//}),define("vs/languages/typescript/common/features/quickFixMainActions",["require","exports","vs/base/common/strings","vs/base/common/errors","vs/base/common/winjs.base","vs/base/common/paths"],function(e,t,n,r,i,a){var o=function(){function e(e){this._requestService=e.requestService,this._fileService=e.fileService,this._contextService=e.contextService}return e.prototype.evaluate=function(e,t,n){var r=JSON.parse(n);switch(r.type){case"addtripleslash":return this.evaluateTripleSlashQuickFix(r.name,e)}return i.Promise.as(null)},e.prototype.evaluateTripleSlashQuickFix=function(e,t){var i=this,o="/typings/"+e,s=this._contextService.toWorkspaceRelativePath(t);s||(s=t.toString());var c=n.rtrim(a.dirname(s),"/"),l=a.relative(c,o),u=n.format('/// <reference path="{0}"/>\n',l),d={edits:[{resource:t,range:{startLineNumber:1,startColumn:1,endLineNumber:1,endColumn:1},newText:u}]};return this._fileService.resolveFileStat(o).then(function(){return d},function(){var t="https://raw.githubusercontent.com/borisyankov/DefinitelyTyped/master/"+e;return i._requestService.makeRequest({url:t,followRedirects:5}).then(function(e){return i._fileService.createFile(o,e.responseText).then(function(){return d},function(){return d})},function(e){return r.onUnexpectedError(n.format("Unable to fetch d.ts file at {0}: {1}",t,e.toString())),d})})},e}();t.QuickFixMainActions=o}),define("vs/languages/typescript/common/typescript",["require","exports","vs/platform/platform","vs/base/common/uri"],function(e,t,n,r){function i(){return{resolveProjects:function(){return void 0},resolveFiles:function(){return void 0}}}function a(e){return"string"==typeof e?0===e.indexOf("ts://defaultlib"):"ts"===e.scheme&&"defaultlib"===e.authority}!function(e){e[e.Changed=0]="Changed",e[e.Added=1]="Added",e[e.Removed=2]="Removed"}(t.ChangeKind||(t.ChangeKind={}));t.ChangeKind;t.createDefaultProjectResolver=i,t.defaultLib=r.create("ts","defaultlib","/vs/text!vs/languages/typescript/common/lib/lib.d.ts"),t.defaultLibES6=r.create("ts","defaultlib","/vs/text!vs/languages/typescript/common/lib/lib.es6.d.ts"),t.isDefaultLib=a,t.virtualProjectResource=r.create("ts","projects","/virtual/1");var o;!function(e){function t(e){i=e}function r(){return i}e.Identifier="typescript",n.Registry.add(e.Identifier,e);var i;e.setProjectResolver=t,e.getProjectResolver=r}(o=t.Extensions||(t.Extensions={}))});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/languages/typescript/common/typescriptMode",["require","exports","vs/base/common/winjs.base","vs/base/common/uri","vs/editor/common/common","vs/base/common/lifecycle","vs/base/common/async","vs/editor/common/modes/supports","vs/languages/typescript/common/features/tokenization","vs/languages/typescript/common/features/quickFixMainActions","vs/languages/typescript/common/typescript","vs/editor/common/modes/abstractMode","vs/platform/thread/common/threadService","vs/platform/instantiation/common/descriptors","vs/platform/thread/common/thread"],function(e,t,n,r,i,a,o,s,c,l,u,d,p,m,h){var f=function(){function e(e,t){this._listener=Object.create(null),this._lastValidationReq=0,this._modelService=e.modelService,this._mode=t,this._validation=new o.RunOnceScheduler(this._doValidate.bind(this),750),this._modelService?(this._modelService.onModelAdded.add(this._onModelAdded,this),this._modelService.onModelRemoved.add(this._onModelRemoved,this),this._modelService.getModels().forEach(this._onModelAdded,this)):console.warn("NO model service for validation")}return e.prototype.dispose=function(){this._validation.dispose()},e.prototype.validateOpen=function(){this._scheduleValidation()},e.prototype._scheduleValidation=function(e){this._lastValidationReq+=1,this._lastChangedResource=e,this._validation.schedule()},e.prototype._doValidate=function(){var e=this,t=[];this._lastChangedResource&&t.push(this._lastChangedResource);for(var i in this._listener)this._lastChangedResource&&i===this._lastChangedResource.toString()||t.push(r.parse(i));var a=this._lastValidationReq,s=o.sequence(t.map(function(t){return function(){return e._modelService.getModel(t)?a===e._lastValidationReq?e._mode.performSemanticValidation(t):void 0:n.Promise.as(void 0)}}));s.done(void 0,function(e){return console.warn(e)})},e.prototype._onModelAdded=function(e){var t=this;if(this._mode._shouldBeValidated(e)){var n,r;n=function(){t._scheduleValidation(e.getAssociatedResource())},r=e.addListener(i.EventType.ModelContentChanged2,function(){return n()}),this._listener[e.getAssociatedResource().toString()]=r,n()}},e.prototype._onModelRemoved=function(e){var t=this._listener[e.getAssociatedResource().toString()];t&&(t(),delete this._listener[e.getAssociatedResource().toString()])},e}(),g=function(t){function r(e,r,i){var a=this;if(t.call(this,e,r,i,m.AsyncDescriptor.create("vs/languages/typescript/common/typescriptWorker2","TypeScriptWorker2")),this._disposables=[],this._telemetryService=e.telemetryService,this._threadService&&this._threadService.isInMainThread){this._semanticValidator=e.instantiationService.createInstance(f,this),this._disposables.push(this._semanticValidator);var o=this._getProjectResolver();this._projectResolver=o?e.instantiationService.createInstance(o,this).then(void 0,function(e){return console.error(e),u.createDefaultProjectResolver()}):n.TPromise.as(u.createDefaultProjectResolver())}this.navigateTypesSupport=this,this.extraInfoSupport=this,this.formattingSupport=this,this.quickFixSupport=this,this.logicalSelectionSupport=this,this.outlineSupport=this,this.emitOutputSupport=this,this.codeLensSupport=this,this.renameSupport=this,this.tokenizationSupport=c.createTokenizationSupport(this,c.Language.TypeScript),this.electricCharacterSupport=new s.BracketElectricCharacterSupport(this,{brackets:[{tokenType:"delimiter.bracket.ts",open:"{",close:"}",isElectric:!0},{tokenType:"delimiter.array.ts",open:"[",close:"]",isElectric:!0},{tokenType:"delimiter.parenthesis.ts",open:"(",close:")",isElectric:!0}],docComment:{scope:"comment.doc",open:"/**",lineStart:" * ",close:" */"}}),this.referenceSupport=new s.ReferenceSupport(this,{tokens:["identifier.ts"],findReferences:function(e,t,n){return a.findReferences(e,t,n)}}),this.declarationSupport=new s.DeclarationSupport(this,{tokens:["identifier.ts","string.ts","attribute.value.vs"],findDeclaration:function(e,t){return a.findDeclaration(e,t)}}),this.parameterHintsSupport=new s.ParameterHintsSupport(this,{triggerCharacters:["(",","],excludeTokens:["string.ts"],getParameterHints:function(e,t){return a.getParameterHints(e,t)}}),this.characterPairSupport=new s.CharacterPairSupport(this,{autoClosingPairs:[{open:"{",close:"}"},{open:"[",close:"]"},{open:"(",close:")"},{open:'"',close:'"',notIn:["string"]},{open:"'",close:"'",notIn:["string","comment"]},{open:"`",close:"`"}]}),this.suggestSupport=new s.SuggestSupport(this,{triggerCharacters:["."],excludeTokens:["string","comment","number"],sortBy:[{type:"reference",partSeparator:"/"}],suggest:function(e,t){return a.suggest(e,t)},getSuggestionDetails:function(e,t,n){return a.getSuggestionDetails(e,t,n)}})}return __extends(r,t),r.prototype.dispose=function(){this._disposables=a.disposeAll(this._disposables)},r.prototype._shouldBeValidated=function(e){return e.getMode()===this||/\.ts$/.test(e.getAssociatedResource().fsPath)},r.prototype._getProjectResolver=function(){return u.Extensions.getProjectResolver()},r.prototype.acceptProjectChanges=function(e){return this._semanticValidator.validateOpen(),this._doAcceptProjectChanges(e)},r.prototype._doAcceptProjectChanges=function(e){return this._worker(function(t){return t.acceptProjectChanges(e)})},r.prototype.acceptFileChanges=function(e){return this._semanticValidator.validateOpen(),this._doAcceptFileChanges(e)},r.prototype._doAcceptFileChanges=function(e){return this._worker(function(t){return t.acceptFileChanges(e)})},r.prototype._defaultLib=function(){var t=this;if(!this._defaultLibPromise){var r=[],i=new n.TPromise(function(t,n){return e([u.defaultLib.path.substr(1)],t,n)}).then(function(e){r.push({kind:u.ChangeKind.Added,resource:u.defaultLib,content:e})}),a=new n.TPromise(function(t,n){return e([u.defaultLibES6.path.substr(1)],t,n)}).then(function(e){r.push({kind:u.ChangeKind.Added,resource:u.defaultLibES6,content:e})});this._defaultLibPromise=n.TPromise.join([i,a]).then(function(){return t.acceptFileChanges(r)})}return new o.ShallowCancelThenPromise(this._defaultLibPromise)},r.prototype._syncProjects=function(){var e=this;return this._projectResolver?this._defaultLib().then(function(){return e._projectResolver}).then(function(e){return e.resolveProjects()}):void 0},r.prototype.configure=function(e){var n=this,r=t.prototype.configure.call(this,e);return this._semanticValidator&&r.then(function(e){return e&&n._semanticValidator.validateOpen()}),r},r.prototype._worker=function(e){return t.prototype._worker.call(this,e)},r.prototype.getCommentsConfiguration=function(){return{lineCommentTokens:["//"],blockCommentStartToken:"/*",blockCommentEndToken:"*/"}},r.prototype._pickAWorkerToValidate=function(){return this._worker(function(e){return e.enableValidator()})},r.prototype.performSemanticValidation=function(e){var t=this;return this.doValidateSemantics(e).then(function(e){return e?t.getMissingFiles().then(function(e){return e?t._projectResolver.then(function(t){return t.resolveFiles(e)}):void 0}):void 0})},r.prototype.doValidateSemantics=function(e){return this._worker(function(t){return t.doValidateSemantics(e)})},r.prototype.getMissingFiles=function(){return this._worker(function(e){return e.getMissingFiles()})},r.prototype.getOutline=function(e){return this._worker(function(t){return t.getOutline(e)})},r.prototype.findOccurrences=function(e,t,n){return void 0===n&&(n=!1),this._worker(function(r){return r.findOccurrences(e,t,n)})},r.prototype.suggest=function(e,t){return this._worker(function(n){return n.suggest(e,t)})},r.prototype.getSuggestionDetails=function(e,t,n){return this._worker(function(r){return r.getSuggestionDetails(e,t,n)})},r.prototype.getParameterHints=function(e,t){return this._worker(function(n){return n.getParameterHints(e,t)})},r.prototype.getEmitOutput=function(e,t){return void 0===t&&(t=void 0),this._worker(function(n){return n.getEmitOutput(e,t)})},r.prototype.getWordDefinition=function(){return r.WORD_DEFINITION},r.prototype.findReferences=function(e,t,n){return this._worker(function(r){return r.findReferences(e,t,n)})},Object.defineProperty(r.prototype,"filter",{get:function(){return["identifier.ts","string.ts"]},enumerable:!0,configurable:!0}),r.prototype.rename=function(e,t,n){return this._worker(function(r){return r.rename(e,t,n)})},r.prototype.getNavigateToItems=function(e){return this._worker(function(t){return t.getNavigateToItems(e)})},r.prototype.runQuickFixAction=function(e,t,n){var r=this,i=this._instantiationService.createInstance(l.QuickFixMainActions);return i.evaluate(e,t,n).then(function(i){return i?i:r.runQuickFixActionInWorker(e,t,n)})},r.prototype.runQuickFixActionInWorker=function(e,t,n){return this._worker(function(r){return r.runQuickFixAction(e,t,n)})},r.prototype.getQuickFixes=function(e,t){return this._worker(function(n){return n.getQuickFixes(e,t)})},r.prototype.getRangesToPosition=function(e,t){return this._worker(function(n){return n.getRangesToPosition(e,t)})},r.prototype.findDeclaration=function(e,t){return this._worker(function(n){return n.findDeclaration(e,t)})},r.prototype.computeInfo=function(e,t){return this._worker(function(n){return n.computeInfo(e,t)})},r.prototype.getAutoFormatTriggerCharacters=function(){return[";","}","\n"]},r.prototype.formatDocument=function(e,t){return this._worker(function(n){return n.formatDocument(e,t)})},r.prototype.formatRange=function(e,t,n){return this._worker(function(r){return r.formatRange(e,t,n)})},r.prototype.formatAfterKeystroke=function(e,t,n,r){return this._worker(function(i){return i.formatAfterKeystroke(e,t,n,r)})},r.prototype.enableCodeLens=function(){return this._options&&this._options.referenceInfos===!0},r.prototype.findCodeLensSymbols=function(e){return this._worker(function(t){return t.findCodeLensSymbols(e)})},r.prototype.findCodeLensReferences=function(e,t){return this._worker(function(n){return n.findCodeLensReferences(e,t)})},r.$_doAcceptProjectChanges=p.AllWorkersAttr(r,r.prototype._doAcceptProjectChanges),r.$_doAcceptFileChanges=p.AllWorkersAttr(r,r.prototype._doAcceptFileChanges),r.$_pickAWorkerToValidate=p.OneWorkerAttr(r,r.prototype._pickAWorkerToValidate,r.prototype._syncProjects,h.ThreadAffinity.Group3),r.$doValidateSemantics=p.OneWorkerAttr(r,r.prototype.doValidateSemantics,r.prototype._syncProjects,h.ThreadAffinity.Group3),r.$getMissingFiles=p.OneWorkerAttr(r,r.prototype.getMissingFiles,r.prototype._syncProjects,h.ThreadAffinity.Group3),r.$getOutline=p.OneWorkerAttr(r,r.prototype.getOutline,r.prototype._syncProjects,h.ThreadAffinity.Group1),r.$findOccurrences=p.OneWorkerAttr(r,r.prototype.findOccurrences,r.prototype._syncProjects,h.ThreadAffinity.Group2),r.$suggest=p.OneWorkerAttr(r,r.prototype.suggest,r.prototype._syncProjects,h.ThreadAffinity.Group2),r.$getSuggestionDetails=p.OneWorkerAttr(r,r.prototype.getSuggestionDetails,r.prototype._syncProjects,h.ThreadAffinity.Group2),r.$getParameterHints=p.OneWorkerAttr(r,r.prototype.getParameterHints,r.prototype._syncProjects,h.ThreadAffinity.Group2),r.$getEmitOutput=p.OneWorkerAttr(r,r.prototype.getEmitOutput,r.prototype._syncProjects,h.ThreadAffinity.Group3),r.WORD_DEFINITION=d.createWordRegExp("$"),r.$findReferences=p.OneWorkerAttr(r,r.prototype.findReferences,r.prototype._syncProjects,h.ThreadAffinity.Group3),r.$rename=p.OneWorkerAttr(r,r.prototype.rename,r.prototype._syncProjects,h.ThreadAffinity.Group2),r.$getNavigateToItems=p.OneWorkerAttr(r,r.prototype.getNavigateToItems,r.prototype._syncProjects,h.ThreadAffinity.Group3),r.$runQuickFixActionInWorker=p.OneWorkerAttr(r,r.prototype.runQuickFixActionInWorker,r.prototype._syncProjects,h.ThreadAffinity.Group2),r.$getQuickFixes=p.OneWorkerAttr(r,r.prototype.getQuickFixes,r.prototype._syncProjects,h.ThreadAffinity.Group2),r.$getRangesToPosition=p.OneWorkerAttr(r,r.prototype.getRangesToPosition,r.prototype._syncProjects,h.ThreadAffinity.Group1),r.$findDeclaration=p.OneWorkerAttr(r,r.prototype.findDeclaration,r.prototype._syncProjects,h.ThreadAffinity.Group2),r.$computeInfo=p.OneWorkerAttr(r,r.prototype.computeInfo,r.prototype._syncProjects,h.ThreadAffinity.Group2),r.$formatDocument=p.OneWorkerAttr(r,r.prototype.formatDocument,r.prototype._syncProjects,h.ThreadAffinity.Group1),r.$formatRange=p.OneWorkerAttr(r,r.prototype.formatRange,r.prototype._syncProjects,h.ThreadAffinity.Group1),r.$formatAfterKeystroke=p.OneWorkerAttr(r,r.prototype.formatAfterKeystroke,r.prototype._syncProjects,h.ThreadAffinity.Group1),r.findCodeLensSymbols=p.OneWorkerAttr(r,r.prototype.findCodeLensSymbols,r.prototype._syncProjects,h.ThreadAffinity.Group1),r.findCodeLensReferences=p.OneWorkerAttr(r,r.prototype.findCodeLensReferences,r.prototype._syncProjects,h.ThreadAffinity.Group3),r}(d.AbstractMode);t.TypeScriptMode=g});