/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n},__decorate=this&&this.__decorate||function(e,t,n,r){if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)return Reflect.decorate(e,t,n,r);switch(arguments.length){case 2:return e.reduceRight(function(e,t){return t&&t(e)||e},t);case 3:return e.reduceRight(function(e,r){return r&&r(t,n),void 0},void 0);case 4:return e.reduceRight(function(e,r){return r&&r(t,n,e)||e},r)}},__param=this&&this.__param||function(e,t){return function(n,r){t(n,r,e)}};define("vs/workbench/parts/search/common/searchModel",["require","exports","vs/base/common/async","vs/base/common/strings","vs/base/common/paths","vs/base/common/lifecycle","vs/base/common/collections","vs/base/common/eventEmitter","vs/editor/common/common","vs/editor/common/core/range","vs/editor/common/services/modelService"],function(e,t,n,r,i,o,a,s,c,u,l){var p=function(){function e(e,t,n,r,i){this._parent=e,this._lineText=t,this._id=e.id()+">"+n+">"+r,this._range=u.Range.create(1+n,1+r,1+n,1+r+i)}return e.prototype.id=function(){return this._id},e.prototype.parent=function(){return this._parent},e.prototype.text=function(){return this._lineText},e.prototype.range=function(){return this._range},e.prototype.preview=function(){var e=this._lineText.substring(0,this._range.startColumn-1),t=this._lineText.substring(this._range.startColumn-1,this._range.endColumn-1),n=this._lineText.substring(this._range.endColumn-1,Math.min(this._range.endColumn+150,this._lineText.length));return e=r.lcut(e,26),{before:e,inside:t,after:n}},e}();t.Match=p;var d=function(e){function t(t){e.call(this,t,null,Date.now(),Date.now(),Date.now())}return __extends(t,e),t}(p);t.EmptyMatch=d;var m=function(){function e(e,t){this._resource=t,this._parent=e,this._matches=Object.create(null)}return e.prototype.dispose=function(){},e.prototype.id=function(){return this.resource().toString()},e.prototype.parent=function(){return this._parent},e.prototype.add=function(e){this._matches[e.id()]=e},e.prototype.remove=function(e){delete this._matches[e.id()]},e.prototype.matches=function(){return a.values(this._matches)},e.prototype.count=function(){var e=0;for(var t in this._matches)this._matches[t]instanceof d||(e+=1);return e},e.prototype.resource=function(){return this._resource},e.prototype.name=function(){return i.basename(this.resource().fsPath)},e}();t.FileMatch=m;var h=function(e){function t(t,r,i,o,a){var s=this;e.call(this,t,r),this._modelDecorations=[],this._unbind=[],this._query=i,this._model=o,this._diskFileMatch=a,this._updateScheduler=new n.RunOnceScheduler(this._updateMatches.bind(this),250),this._unbind.push(this._model.addListener(c.EventType.ModelContentChanged,function(){return s._updateScheduler.schedule()})),this._updateMatches()}return __extends(t,e),t.prototype.dispose=function(){this._unbind=o.cAll(this._unbind),this._isTextModelDisposed()||this._model.deltaDecorations(this._modelDecorations,[])},t.prototype._updateMatches=function(){var e=this;if(!this._isTextModelDisposed()){this._matches=Object.create(null);var t=this._model.findMatches(this._query.pattern,this._model.getFullModelRange(),this._query.isRegExp,this._query.isCaseSensitive,this._query.isWordMatch);0===t.length?this.add(new d(this)):t.forEach(function(t){return e.add(new p(e,e._model.getLineContent(t.startLineNumber),t.startLineNumber-1,t.startColumn-1,t.endColumn-t.startColumn))}),this.parent().emit("changed",this),this.updateHighlights()}},t.prototype.updateHighlights=function(){this._model.isDisposed()||(this._modelDecorations=this.parent()._showHighlights?this._model.deltaDecorations(this._modelDecorations,this.matches().filter(function(e){return!(e instanceof d)}).map(function(e){return{range:e.range(),options:t.DecorationOption}})):this._model.deltaDecorations(this._modelDecorations,[]))},t.prototype._isTextModelDisposed=function(){return!this._model||this._model.isDisposed()},t.DecorationOption={stickiness:c.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges,isOverlay:!1,className:"findMatch",overviewRuler:{color:"rgba(246, 185, 77, 0.7)",position:c.OverviewRulerLane.Center}},t}(m);t.LiveFileMatch=h;var f=function(e){function t(t,n){e.call(this),this._disposables=[],this._matches=Object.create(null),this._modelService=n,this._query=t,this._query&&(this._modelService.onModelAdded.add(this._onModelAdded,this,this._disposables),this._modelService.onModelRemoved.add(this._onModelRemoved,this,this._disposables))}return __extends(t,e),t.prototype._onModelAdded=function(e){var t=e.getAssociatedResource(),n=this._matches[t.toString()];if(n){var r=new h(this,t,this._query,e,n);r.updateHighlights(),this._matches[t.toString()]=r,this.emit("changed",this)}},t.prototype._onModelRemoved=function(e){var t=this,n=e.getAssociatedResource(),r=this._matches[n.toString()];r instanceof h&&this.deferredEmit(function(){t.remove(r),t._matches[n.toString()]=r._diskFileMatch})},t.prototype.append=function(e){var t=this;e.forEach(function(e){var n=t._getOrAdd(e);n instanceof h&&(n=n._diskFileMatch),e.lineMatches.forEach(function(e){e.offsetAndLengths.forEach(function(t){var r=new p(n,e.preview,e.lineNumber,t[0],t[1]);n.add(r)})})})},t.prototype._getOrAdd=function(e){var t=this;return a.lookupOrInsert(this._matches,e.resource.toString(),function(){var n=t._modelService.getModel(e.resource),r=new m(t,e.resource);return n&&t._query&&(r=new h(t,e.resource,t._query,n,r)),r})},t.prototype.remove=function(e){delete this._matches[e.resource().toString()],e.dispose(),this.emit("changed",this)},t.prototype.matches=function(){return a.values(this._matches)},t.prototype.isEmpty=function(){return 0===this.fileCount()},t.prototype.fileCount=function(){return Object.keys(this._matches).length},t.prototype.count=function(){return this.matches().reduce(function(e,t){return e+t.count()},0)},t.prototype.toggleHighlights=function(e){if(this._showHighlights!==e){this._showHighlights=e;for(var t in this._matches){var n=this._matches[t];n instanceof h&&n.updateHighlights()}}},t.prototype.dispose=function(){this._disposables=o.disposeAll(this._disposables),o.disposeAll(this.matches()),e.prototype.dispose.call(this)},t=__decorate([__param(1,l.IModelService)],t)}(s.EventEmitter);t.SearchResult=f}),define("vs/workbench/parts/search/common/searchQuery",["require","exports","vs/base/common/assert","vs/base/common/types","vs/base/common/objects","vs/base/common/winjs.base","vs/base/common/lifecycle","vs/platform/search/common/search","vs/platform/configuration/common/configuration"],function(e,t,n,r,i,o,a,s,c){function u(e){var t=e&&e.files&&e.files.exclude,n=e&&e.search&&e.search.exclude;if(!t&&!n)return null;if(!t||!n)return t||n;var r=Object.create(null);return r=i.mixin(r,t),r=i.mixin(r,n,!0)}t.getExcludes=u;var l=function(){function e(e){var t=this;this.configurationService=e.configurationService,this.callOnDispose=[],this.callOnDispose.push(this.configurationService.addListener(c.ConfigurationServiceEventTypes.UPDATED,function(e){t.configurationPromise=o.Promise.as(e.config)}))}return e.prototype.dispose=function(){a.cAll(this.callOnDispose)},e.prototype.text=function(e,t){return this._query(s.QueryType.Text,e,t)},e.prototype.file=function(e){return this._query(s.QueryType.File,null,e)},e.prototype._query=function(e,t,n){return void 0===n&&(n={}),this.loadConfiguration().then(function(r){var o=r&&r.files&&r.files.encoding;n.fileEncoding=o;var a=u(r);return n.excludePattern?i.mixin(n.excludePattern,a,!1):n.excludePattern=a,new p(e,t,n)})},e.prototype.loadConfiguration=function(){return this.configurationPromise?this.configurationPromise:(this.configurationPromise=this.configurationService.loadConfiguration(),this.configurationPromise)},e}();t.QueryBuilder=l;var p=function(){function e(e,t,i){void 0===i&&(i={}),n.ok(!r.isUndefinedOrNull(e)),n.ok(e!==s.QueryType.Text||t&&t.pattern&&0!==t.pattern.length),this._type=e,this._contentPattern=t,this._filePatterns=i.filePatterns||[],this._excludePattern=i.excludePattern,this._includePattern=i.includePattern,this._maxResults=i.maxResults,this._rootResources=i.rootResources,this._fileEncoding=i.fileEncoding}return Object.defineProperty(e.prototype,"type",{get:function(){return this._type},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"contentPattern",{get:function(){return this._contentPattern},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"filePatterns",{get:function(){return this._filePatterns},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"excludePattern",{get:function(){return this._excludePattern},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"includePattern",{get:function(){return this._includePattern},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"maxResults",{get:function(){return this._maxResults},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"rootResources",{get:function(){return this._rootResources},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"fileEncoding",{get:function(){return this._fileEncoding},enumerable:!0,configurable:!0}),e.prototype.toJSON=function(){return{type:this.type,contentPattern:this.contentPattern,filePatterns:this.filePatterns,excludePattern:this._excludePattern,includePattern:this._includePattern,maxResults:this._maxResults,rootResources:this._rootResources,fileEncoding:this._fileEncoding}},e}()}),define("vs/css!vs/workbench/parts/search/browser/media/searchviewlet",["vs/css!vs/workbench/parts/search/browser/searchViewlet"],{});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n},__decorate=this&&this.__decorate||function(e,t,n,r){if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)return Reflect.decorate(e,t,n,r);switch(arguments.length){case 2:return e.reduceRight(function(e,t){return t&&t(e)||e},t);case 3:return e.reduceRight(function(e,r){return r&&r(t,n),void 0},void 0);case 4:return e.reduceRight(function(e,r){return r&&r(t,n,e)||e},r)}},__param=this&&this.__param||function(e,t){return function(n,r){t(n,r,e)}};define("vs/workbench/parts/search/browser/searchViewlet",["require","exports","vs/base/common/winjs.base","vs/nls!vs/workbench/parts/search/browser/searchViewlet","vs/editor/common/common","vs/base/common/lifecycle","vs/base/common/errors","vs/base/common/assert","vs/base/common/glob","vs/base/common/types","vs/base/common/strings","vs/base/browser/dom","vs/base/common/actions","vs/base/browser/keyboardEvent","vs/base/common/timer","vs/base/browser/builder","vs/base/browser/ui/filelabel/fileLabel","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/leftRightWidget/leftRightWidget","vs/base/browser/ui/countBadge/countBadge","vs/base/parts/tree/browser/treeImpl","vs/base/parts/tree/browser/treeDefaults","vs/base/parts/tree/browser/actionsRenderer","vs/workbench/browser/ui/actionBarRegistry","vs/workbench/browser/core/memento","vs/workbench/browser/ui/actions/openSettings","vs/workbench/browser/events","vs/workbench/parts/files/common/files","vs/platform/files/common/files","vs/workbench/browser/ui/viewlet","vs/workbench/parts/search/common/searchModel","vs/workbench/parts/search/common/searchQuery","vs/base/browser/ui/checkbox/checkbox","vs/workbench/parts/search/browser/search.contribution","vs/base/browser/ui/inputbox/inputBox","vs/workbench/services/editor/common/editorService","vs/workbench/services/viewlet/common/viewletService","vs/editor/common/core/range","vs/platform/storage/common/storage","vs/platform/configuration/common/configuration","vs/platform/contextview/browser/contextView","vs/platform/event/common/event","vs/platform/instantiation/common/instantiation","vs/platform/message/browser/message","vs/platform/search/common/search","vs/platform/progress/common/progress","vs/platform/workspace/common/workspace","vs/platform/selection/common/selection","vs/platform/keybinding/common/keybindingService","vs/platform/telemetry/common/telemetry","vs/css!./media/searchviewlet"],function(e,t,n,r,i,o,a,s,c,u,l,p,d,m,h,f,g,v,y,_,b,E,T,S,k,C,w,x,A,L,N,P,O,I,M,R,D,F,V,B,$,j,U,G,H,z,W,q,K,Y){var X=x.ITextFileService,J=f.$,Q=I.VIEWLET_ID,Z=function(e){function t(t,n){e.call(this,"workbench.search.action.findInFolder",r.localize("vs_workbench_parts_search_browser_searchViewlet",0)),this.viewletService=n,this.resource=t}return __extends(t,e),t.prototype.run=function(){var e=this;return this.viewletService.openViewlet(Q,!0).then(function(t){t.searchInFolder(e.resource)})},t=__decorate([__param(1,D.IViewletService)],t)}(d.Action);t.FindInFolderAction=Z;var et=function(){function e(){}return e.prototype.getId=function(e,t){return t instanceof N.FileMatch?t.id():t instanceof N.Match?t.id():t instanceof N.SearchResult?"root":(s.ok(!1),void 0)},e.prototype.getChildren=function(e,t){var r=[];return t instanceof N.FileMatch?r=t.matches():t instanceof N.SearchResult&&(r=t.matches()),n.Promise.as(r)},e.prototype.hasChildren=function(e,t){return t instanceof N.FileMatch||t instanceof N.SearchResult},e.prototype.getParent=function(e,t){var r=null;return t instanceof N.Match?r=t.parent():t instanceof N.FileMatch&&(r=t.parent()),n.Promise.as(r)},e}();t.SearchDataSource=et;var tt=function(){function e(){}return e.prototype.compare=function(e,t,n){return t instanceof N.FileMatch&&n instanceof N.FileMatch?l.localeCompare(t.resource().fsPath,n.resource().fsPath)||l.localeCompare(t.name(),n.name()):t instanceof N.Match&&n instanceof N.Match?F.Range.compareRangesUsingStarts(t.range(),n.range()):void 0},e}();t.SearchSorter=tt;var nt=function(e){function t(){var t=this;e.call(this,{clickBehavior:E.ClickBehavior.ON_MOUSE_DOWN}),this.downKeyBindings.Delete=function(e,n){t.onDelete(e,n)}}return __extends(t,e),t.prototype.onDelete=function(e){for(var t=!1,n=e.getSelection(),r=0;r<n.length;r++){var i=n[r];i instanceof N.FileMatch&&(new ot(e,i).run().done(null,a.onUnexpectedError),t=!0)}return t},t}(E.DefaultController),rt=function(){function e(){}return e.prototype.isVisible=function(e,t){return!(t instanceof N.FileMatch)||t.matches().length>0},e}(),it=function(e){function t(){e.apply(this,arguments)}return __extends(t,e),t.prototype.hasActions=function(t,n){return n instanceof N.FileMatch||e.prototype.hasActions.call(this,t,n)},t.prototype.getActions=function(t,n){return e.prototype.getActions.call(this,t,n).then(function(e){return n instanceof N.FileMatch&&e.unshift(new ot(t,n)),e})},t}(S.ContributableActionProvider),ot=function(e){function t(t,n){e.call(this,"remove",r.localize("vs_workbench_parts_search_browser_searchViewlet",1),"action-remove"),this._viewer=t,this._fileMatch=n}return __extends(t,e),t.prototype.run=function(){var e=this._fileMatch.parent();return e.remove(this._fileMatch),this._viewer.refresh(e)},t}(d.Action),at=function(e){function t(t,n){e.call(this,{actionProvider:new it,actionRunner:t}),this._contextService=n}return __extends(t,e),t.prototype.getContentHeight=function(){return 24},t.prototype.renderContents=function(e,t,n){var i=this;if(t instanceof N.FileMatch){var o,a,s,c=t,u=J(".filematch");return o=function(e){return new g.FileLabel(e,c.resource(),i._contextService),null},a=function(e){var t=c.count();return new _.CountBadge(e,t,t>1?r.localize("vs_workbench_parts_search_browser_searchViewlet",2,t):r.localize("vs_workbench_parts_search_browser_searchViewlet",3,t))},s=new y.LeftRightWidget(u,o,a),u.appendTo(n),s.dispose.bind(s)}if(t instanceof N.EmptyMatch)p.addClass(n,"linematch"),J("a.plain.label").innerHtml(r.localize("vs_workbench_parts_search_browser_searchViewlet",4)).appendTo(n);else if(t instanceof N.Match){p.addClass(n,"linematch");var d=[],m=t.preview();d.push("<span>"),d.push(l.escape(m.before)),d.push('</span><span class="findInFileMatch">'),d.push(l.escape(m.inside)),d.push("</span><span>"),d.push(l.escape(m.after)),d.push("</span>"),J("a.plain").innerHtml(d.join(l.empty)).appendTo(n)}return null},t=__decorate([__param(1,W.IWorkspaceContextService)],t)}(T.ActionsRenderer),st=function(e){function t(t){e.call(this,"refresh"),this.label=r.localize("vs_workbench_parts_search_browser_searchViewlet",5),this.enabled=!1,this.class="search-action refresh",this.viewlet=t}return __extends(t,e),t.prototype.run=function(){return this.viewlet.onQueryChanged(!0),n.Promise.as(null)},t}(d.Action);t.RefreshAction=st;var ct=function(e){function t(t){e.call(this,"selectOrRemove"),this.label=r.localize("vs_workbench_parts_search_browser_searchViewlet",6),this.enabled=!1,this.selectMode=!0,this.viewlet=t}return __extends(t,e),t.prototype.run=function(){var e;return e=this.selectMode?this.runAsSelect():this.runAsRemove(),this.selectMode=!this.selectMode,this.label=this.selectMode?r.localize("vs_workbench_parts_search_browser_searchViewlet",7):r.localize("vs_workbench_parts_search_browser_searchViewlet",8),e},t.prototype.runAsSelect=function(){return this.viewlet.getResults().addClass("select"),n.Promise.as(null)},t.prototype.runAsRemove=function(){var e=[],t=this.viewlet.getControl();return t.getInput().matches().forEach(function(t){t.matches().filter(function(e){return e.$checked}).forEach(function(t){t.parent().remove(t),e.push(t.parent())})}),this.viewlet.getResults().removeClass("select"),e.length>0?t.refreshAll(e).then(function(){return t.refresh()}):n.Promise.as(null)},t}(d.Action);t.SelectOrRemoveAction=ct;var ut=function(e){function t(t){e.call(this,"collapseAll"),this.label=r.localize("vs_workbench_parts_search_browser_searchViewlet",9),this.enabled=!1,this.class="search-action collapse",this.viewlet=t}return __extends(t,e),t.prototype.run=function(){return this.viewlet.getControl()?this.viewlet.getControl().collapseAll():n.Promise.as(null)},t}(d.Action);t.CollapseAllAction=ut;var lt=function(e){function t(t){e.call(this,"clearSearchResults"),this.label=r.localize("vs_workbench_parts_search_browser_searchViewlet",10),this.enabled=!1,this.class="search-action clear-search-results",this.viewlet=t}return __extends(t,e),t.prototype.run=function(){return this.viewlet.clearSearchResults(),n.Promise.as(null)},t}(d.Action);t.ClearSearchResultsAction=lt;var pt=function(e){function t(t){e.call(this,"configureGlobalExclusionsAction"),this.label=r.localize("vs_workbench_parts_search_browser_searchViewlet",11),this.enabled=!0,this.class="search-configure-exclusions",this.instantiationService=t}return __extends(t,e),t.prototype.run=function(){var e=this.instantiationService.createInstance(C.OpenGlobalSettingsAction,C.OpenGlobalSettingsAction.ID,C.OpenGlobalSettingsAction.LABEL);return e.run().done(function(){return e.dispose()},a.onUnexpectedError),n.Promise.as(null)},t=__decorate([__param(0,U.IInstantiationService)],t)}(d.Action),dt=function(){function e(e,t,n){void 0===n&&(n=Object.create(null)),this.contextViewProvider=t,this.onOptionChange=null,this.width=n.width||100,this.placeholder=n.placeholder||"",this.label=n.label||r.localize("vs_workbench_parts_search_browser_searchViewlet",12),this.listenersToRemove=[],this.pattern=null,this.domNode=null,this.inputNode=null,this.inputBox=null,this.buildDomNode(),Boolean(e)&&e.appendChild(this.domNode)}return e.prototype.destroy=function(){this.pattern.destroy(),this.listenersToRemove.forEach(function(e){e()}),this.listenersToRemove=[]},e.prototype.on=function(t,n){switch(t){case"keydown":case"keyup":J(this.inputBox.inputElement).on(t,n);break;case e.OPTION_CHANGE:this.onOptionChange=n}return this},e.prototype.setWidth=function(e){this.width=e,this.domNode.style.width=this.width+"px",this.contextViewProvider.layout(),this.setInputWidth()},e.prototype.getValue=function(){return this.inputBox.value},e.prototype.setValue=function(e){this.inputBox.value!==e&&(this.inputBox.value=e)},e.prototype.getGlob=function(){var e=this.getValue(),t=this.isGlobPattern();if(!e)return void 0;var n,r=Object.create(null);return n=t?c.splitGlobAware(e,",").map(function(e){return e.trim()}).filter(function(e){return!!e.length}):e.split(",").map(function(e){return e.trim()}).filter(function(e){return!!e.length}).map(function(e){return"."===e[0]&&(e="*"+e),l.format("{{0}/**,**/{1}}",e,e)}),n.reduce(function(e,t){return r[t]=!0,r},r)},e.prototype.select=function(){this.inputBox.select()},e.prototype.focus=function(){this.inputBox.focus()},e.prototype.isGlobPattern=function(){return this.pattern.isChecked},e.prototype.setIsGlobPattern=function(e){this.pattern.setChecked(e),this.setInputWidth()},e.prototype.setInputWidth=function(){var e=this.width-this.pattern.width();this.inputBox.width=e},e.prototype.buildDomNode=function(){var e=this;this.domNode=document.createElement("div"),this.domNode.style.width=this.width+"px",J(this.domNode).addClass("monaco-findInput"),this.inputBox=new M.InputBox(this.domNode,this.contextViewProvider,{placeholder:this.placeholder||"",ariaLabel:this.label||"",validationOptions:{validation:null,showMessage:!0}}),this.pattern=new O.Checkbox("pattern",r.localize("vs_workbench_parts_search_browser_searchViewlet",13),!1,function(){e.onOptionChange(null),e.inputBox.focus(),e.setInputWidth(),e.isGlobPattern()?e.showGlobHelp():e.inputBox.hideMessage()}),J(this.pattern.domNode).on("mouseover",function(){e.isGlobPattern()&&e.showGlobHelp()}),J(this.pattern.domNode).on(["mouseleave","mouseout"],function(){e.inputBox.hideMessage()}),this.setInputWidth();var t=document.createElement("div");t.className="controls",t.appendChild(this.pattern.domNode),this.domNode.appendChild(t)},e.prototype.showGlobHelp=function(){this.inputBox.showMessage({type:M.MessageType.INFO,formatContent:!0,content:r.localize("vs_workbench_parts_search_browser_searchViewlet",14)},!0)},e.OPTION_CHANGE="optionChange",e}(),mt=function(e){function t(t,n,r,i,o,a,s,c,u,l,p,d,m){var h=this;e.call(this,Q,t),this.eventService=n,this.editorService=r,this.progressService=i,this.messageService=o,this.storageService=a,this.contextViewService=s,this.instantiationService=c,this.configurationService=u,this.searchServices=p,this.textFileService=d,this.contextService=l,this._viewletVisible=m.createKey("searchViewletVisible",!0),this.callOnModelChange=[],this.queryBuilder=this.instantiationService.createInstance(P.QueryBuilder),this.loadSettings(this.storageService),this.toUnbind.push(this.eventService.addListener(A.EventType.FILE_CHANGES,function(e){return h.onFilesChanged(e)})),this.toUnbind.push(this.eventService.addListener(w.EventType.UNTITLED_FILE_DELETED,function(e){return h.onUntitledFileDeleted(e)})),this.toUnbind.push(this.configurationService.addListener(B.ConfigurationServiceEventTypes.UPDATED,function(e){return h.onConfigurationUpdated(e.config)}))}return __extends(t,e),t.prototype.onConfigurationUpdated=function(e){this.updateGlobalPatternExclusions(e)},t.prototype.loadSettings=function(e){var t=this;this.viewletSettings||this.loadMemento(e,k.Scope.WORKSPACE).done(function(e){t.viewletSettings=e},a.onUnexpectedError)},t.prototype.getResults=function(){return this.results},t.prototype.create=function(t){var i=this;e.prototype.create.call(this,t);var o,s=this.viewletSettings["query.filePatterns"]||"",c=this.viewletSettings["query.folderExclusions"]||"",u=this.viewletSettings["query.exclusionsUsePattern"],d=this.viewletSettings["query.includesUsePattern"],h=this.viewletSettings["query.folderIncludes"]||"",f=this.viewletSettings["query.contentPattern"]||"",g=this.viewletSettings["query.regex"]===!0,y=this.viewletSettings["query.wholeWords"]===!0,_=this.viewletSettings["query.caseSensitive"]===!0;this.domNode=t.div({class:"search-viewlet"},function(e){o=e});var E=function(e){var t=new m.KeyboardEvent(e);"Enter"===t.key?i.onQueryChanged(!0):"Escape"===t.key&&(i.findInput.focus(),i.findInput.select(),i.currentRequest&&(i.currentRequest.cancel(),i.currentRequest=null))};this.queryBox=o.div({class:"query-box"},function(e){var t={label:r.localize("vs_workbench_parts_search_browser_searchViewlet",15),validation:function(e){if(0===e.length)return null;if(!i.findInput.getRegex())return null;var t;try{t=new RegExp(e)}catch(n){return{content:n.message}}return l.regExpLeadsToEndlessLoop(t)?{content:r.localize("vs_workbench_parts_search_browser_searchViewlet",16)}:void 0}};i.findInput=new v.FindInput(e.getHTMLElement(),i.contextViewService,t).on(p.EventType.KEY_UP,E).on(p.EventType.KEY_DOWN,function(e){var t=new m.KeyboardEvent(e);"DownArrow"===t.key&&(p.EventHelper.stop(e),i.showsFileTypes()?i.toggleFileTypes(!0):i.selectTreeIfNotSelected(t))}).on(v.FindInput.OPTION_CHANGE,function(){i.onQueryChanged(!0)}),i.findInput.setValue(f),i.findInput.setRegex(g),i.findInput.setCaseSensitive(_),i.findInput.setWholeWords(y)}).style({position:"relative"}).getHTMLElement(),this.queryDetails=o.div({class:["query-details","separator"]},function(e){e.div({class:"more",text:"…"}).on(p.EventType.CLICK,function(e){p.EventHelper.stop(e),i.toggleFileTypes()}),e.div({class:"file-types"},function(e){var t=r.localize("vs_workbench_parts_search_browser_searchViewlet",17);e.element("h4",{text:t}),i.inputPatternIncludes=new dt(e.getContainer(),i.contextViewService,{label:r.localize("vs_workbench_parts_search_browser_searchViewlet",18)}),i.inputPatternIncludes.setIsGlobPattern(d),i.inputPatternIncludes.setValue(h),i.inputPatternIncludes.on(p.EventType.KEY_UP,E).on(p.EventType.KEY_DOWN,function(e){var t=new m.KeyboardEvent(e);switch(t.asString()){case"UpArrow":p.EventHelper.stop(e),i.findInput.focus(),i.findInput.select();break;case"DownArrow":p.EventHelper.stop(e),i.inputPatternExclusions.focus(),i.inputPatternExclusions.select()}}).on(v.FindInput.OPTION_CHANGE,function(){i.onQueryChanged(!1)})}),e.div({class:"file-types"},function(e){var t=r.localize("vs_workbench_parts_search_browser_searchViewlet",19);e.element("h4",{text:t}),i.inputPatternExclusions=new dt(e.getContainer(),i.contextViewService,{label:r.localize("vs_workbench_parts_search_browser_searchViewlet",20)}),i.inputPatternExclusions.setIsGlobPattern(u),i.inputPatternExclusions.setValue(c),i.inputPatternExclusions.on(p.EventType.KEY_UP,E).on(p.EventType.KEY_DOWN,function(e){var t=new m.KeyboardEvent(e);switch(t.asString()){case"UpArrow":p.EventHelper.stop(e),i.inputPatternIncludes.focus(),i.inputPatternIncludes.select();break;case"DownArrow":p.EventHelper.stop(e),i.selectTreeIfNotSelected(t)}}).on(v.FindInput.OPTION_CHANGE,function(){i.onQueryChanged(!1)})}),i.inputPatternGlobalExclusionsContainer=e.div({class:"file-types global-exclude disabled"},function(e){var t=r.localize("vs_workbench_parts_search_browser_searchViewlet",21);e.element("h4",{text:t}),i.inputPatternGlobalExclusions=new M.InputBox(e.getContainer(),i.contextViewService,{actions:[i.instantiationService.createInstance(pt)]}),i.inputPatternGlobalExclusions.inputElement.readOnly=!0,J(i.inputPatternGlobalExclusions.inputElement).addClass("disabled")}).hide()}).getHTMLElement(),this.messages=o.div({class:"messages"}).hide().clone(),o.div({class:"results"},function(e){i.results=e;var t=new et,n=i.instantiationService.createInstance(at,i.getActionRunner());i.tree=new b.Tree(e.getHTMLElement(),{dataSource:t,renderer:n,sorter:new tt,filter:new rt,controller:new nt},{paddingLeft:12,allowHorizontalScroll:!1}),i.toUnbind.push(function(){return n.dispose()}),i.toUnbind.push(i.tree.addListener("selection",function(e){var t,n=e.payload&&"keyboard"===e.payload.origin;t=n?i.tree.getFocus():e.selection[0];var r=e&&e.payload&&e.payload.originalEvent&&(e.payload.originalEvent.ctrlKey||e.payload.originalEvent.metaKey);i.onFocus(t,!n,r)}))}),this.actionRegistry={};var T=[new ut(this),new st(this),new lt(this),new ct(this)];return T.forEach(function(e){i.actionRegistry[e.id]=e}),(""!==s||""!==c||""!==h)&&this.toggleFileTypes(!0,!0),this.configurationService.loadConfiguration().then(function(e){i.updateGlobalPatternExclusions(e)}).done(null,a.onUnexpectedError),n.Promise.as(null)},t.prototype.updateGlobalPatternExclusions=function(e){if(this.inputPatternGlobalExclusionsContainer){var t=P.getExcludes(e);if(t){var n=Object.getOwnPropertyNames(t).filter(function(e){return t[e]===!0||"string"==typeof t[e].when}).map(function(e){return t[e]===!0?e:r.localize("vs_workbench_parts_search_browser_searchViewlet",22,e,t[e].when)});n.length?(this.inputPatternGlobalExclusions.value=n.join(", "),this.inputPatternGlobalExclusionsContainer.show()):this.inputPatternGlobalExclusionsContainer.hide()}}},t.prototype.setVisible=function(t){var n;if(this._viewletVisible.set(t),t?(n=e.prototype.setVisible.call(this,t),this.tree.onVisible()):(this.tree.onHidden(),n=e.prototype.setVisible.call(this,t)),this.viewModel&&this.viewModel.toggleHighlights(t),t&&!this.editorService.getActiveEditorInput()){var r=this.tree.getFocus();r&&this.onFocus(r,!1,!1)}return n},t.prototype.focus=function(){e.prototype.focus.call(this);var t=this.getSelectionFromEditor();t&&this.findInput.setValue(t),this.findInput.focus(),this.findInput.select()},t.prototype.reLayout=function(){if(!this.isDisposed){this.findInput.setWidth(this.size.width-34),this.inputPatternExclusions.setWidth(this.size.width-42),this.inputPatternIncludes.setWidth(this.size.width-42),this.inputPatternGlobalExclusions.width=this.size.width-42-24;var e=p.getTotalHeight(this.queryBox),t=p.getTotalHeight(this.queryDetails),n=this.size.height-e-t;this.results.style({height:n+"px"}),this.tree.layout(n)}},t.prototype.layout=function(t){var r=this;this.size=t,e.prototype.layout.call(this,t),n.Promise.timeout(10).done(function(){r.reLayout()},a.onUnexpectedError)},t.prototype.getControl=function(){return this.tree},t.prototype.clearSearchResults=function(){this.disposeModel(),this.showEmptyStage(),this.findInput.clear(),this.currentRequest&&(this.currentRequest.cancel(),this.currentRequest=null)},t.prototype.selectTreeIfNotSelected=function(){if(this.tree.getInput()){this.tree.DOMFocus();var e=this.tree.getSelection();0===e.length&&this.tree.focusNext()}},t.prototype.getSelectionFromEditor=function(){if(!this.editorService.getActiveEditor())return null;var e=this.editorService.getActiveEditor().getControl();if(!e||!u.isFunction(e.getEditorType)||e.getEditorType()!==i.EditorType.ICodeEditor)return null;var t=e.getSelection();if(t&&!t.isEmpty()&&t.startLineNumber===t.endLineNumber){var n=e.getModel().getLineContent(t.startLineNumber);return n=n.substring(t.startColumn-1,t.endColumn-1)}return null},t.prototype.showsFileTypes=function(){return p.hasClass(this.queryDetails,"more")},t.prototype.toggleFileTypes=function(e,t){var n="more";e="undefined"==typeof e?!p.hasClass(this.queryDetails,n):Boolean(e),t=Boolean(t),e?(p.addClass(this.queryDetails,n),this.inputPatternIncludes.focus(),this.inputPatternIncludes.select()):p.removeClass(this.queryDetails,n),!t&&this.size&&this.layout(this.size)},t.prototype.searchInFolder=function(e){this.showsFileTypes()||this.toggleFileTypes(!0,!1);var t=this.contextService.toWorkspaceRelativePath(e);t&&(this.inputPatternIncludes.setIsGlobPattern(!1),this.inputPatternIncludes.setValue(l.trim(t,"/")),this.findInput.focus())},t.prototype.onQueryChanged=function(e){var n=this,r=this.findInput.getRegex(),i=this.findInput.getWholeWords(),o=this.findInput.getCaseSensitive(),s=this.findInput.getValue(),c=this.inputPatternExclusions.getValue().trim(),u=this.inputPatternExclusions.isGlobPattern(),p=this.inputPatternIncludes.getValue().trim(),d=this.inputPatternIncludes.isGlobPattern();if(this.viewletSettings["query.contentPattern"]=s,this.viewletSettings["query.regex"]=r,this.viewletSettings["query.wholeWords"]=i,this.viewletSettings["query.caseSensitive"]=o,this.viewletSettings["query.folderExclusions"]=c,this.viewletSettings["query.exclusionsUsePattern"]=u,this.viewletSettings["query.folderIncludes"]=p,this.viewletSettings["query.includesUsePattern"]=d,e&&(/^\s+|\s$/.test(s)&&(s=l.escapeRegExpCharacters(s),r=!0),0!==s.length)){if(r){var m;try{m=new RegExp(s)}catch(h){return}if(l.regExpLeadsToEndlessLoop(m))return
}var f={pattern:s,isRegExp:r,isCaseSensitive:o,isWordMatch:i},g=this.inputPatternExclusions.getGlob(),v=this.inputPatternIncludes.getGlob(),y=this.textFileService.getWorkingFilesModel().getOutOfWorkspaceContextEntries().map(function(e){return e.resource});this.contextService.getWorkspace()&&y.push(this.contextService.getWorkspace().resource);var _={rootResources:y,excludePattern:g,includePattern:v,maxResults:t.MAX_TEXT_RESULTS};this.queryBuilder.text(f,_).then(function(e){return n.onQueryTriggered(e,c,p)},a.onUnexpectedError)}},t.prototype.onQueryTriggered=function(e,t,n){var i=this;this.currentRequest&&(this.currentRequest.cancel(),this.currentRequest=null);var o=this.telemetryService.start("searchResultsFirstRender"),s=this.telemetryService.start("searchResultsFinished"),c=100,u=this.progressService.show(c),l=0;this.loading=!0,this.findInput.clearMessage(),this.disposeModel(),this.showEmptyStage();var d=function(e){if(i.viewModel){var t=i.viewModel.matches();t.forEach(function(n){var r=n.matches().length;10>r||e&&1===t.length&&50>r?i.tree.expand(n).done(null,a.onUnexpectedError):i.tree.collapse(n).done(null,a.onUnexpectedError)})}},m=h.start(h.Topic.WORKBENCH,"Search"),f=!1,g=function(o){m.stop(),f=!0,u.worked(c-l),setTimeout(function(){return u.done()},200),i.viewModel=i.viewModel||i.instantiationService.createInstance(N.SearchResult,e.contentPattern),i.viewModel.append(o.results),i.tree.refresh().then(function(){d(!0)}).done(void 0,a.onUnexpectedError);var h=!i.viewModel.isEmpty();if(i.loading=!1,i.telemetryService.publicLog("searchResultsShown",{count:i.viewModel.count(),fileCount:i.viewModel.fileCount()}),i.actionRegistry.refresh.enabled=!0,i.actionRegistry.selectOrRemove.enabled=h,i.actionRegistry.collapseAll.enabled=h,i.actionRegistry.clearSearchResults.enabled=h,o.limitHit&&i.findInput.showMessage({content:r.localize("vs_workbench_parts_search_browser_searchViewlet",23),type:M.MessageType.WARNING}),h)i.viewModel.toggleHighlights(!0);else{var g,v=!!t,y=!!n;g=y&&v?r.localize("vs_workbench_parts_search_browser_searchViewlet",24,n,t):y?r.localize("vs_workbench_parts_search_browser_searchViewlet",25,n):v?r.localize("vs_workbench_parts_search_browser_searchViewlet",26,t):r.localize("vs_workbench_parts_search_browser_searchViewlet",27),i.tree.onHidden(),i.results.hide();var _=i.messages.empty().show().asContainer().div({class:"message",text:g});y||v?J(_).a({class:["pointer","prominent"],text:r.localize("vs_workbench_parts_search_browser_searchViewlet",28)}).on(p.EventType.CLICK,function(e){p.EventHelper.stop(e,!1),i.inputPatternExclusions.setValue(""),i.inputPatternIncludes.setValue(""),i.onQueryChanged(!0)}):J(_).a({class:["pointer","prominent"],text:r.localize("vs_workbench_parts_search_browser_searchViewlet",29)}).on(p.EventType.CLICK,function(e){p.EventHelper.stop(e,!1);var t=i.instantiationService.createInstance(C.OpenGlobalSettingsAction,C.OpenGlobalSettingsAction.ID,C.OpenGlobalSettingsAction.LABEL);t.run().done(function(){return t.dispose()},a.onUnexpectedError)})}s.stop()},v=function(e){i.loading=!1,f=!0,u.done(),o.stop(),s.stop(),e&&"Canceled"===e.message||i.messageService.show(2,e)},y=0,_=0,b=0,E=[],T=function(t){t.total&&(y=t.total),t.worked&&(_=t.worked),t.resource&&(E.push(t),i.viewModel||(i.viewModel=i.instantiationService.createInstance(N.SearchResult,e.contentPattern),i.tree.setInput(i.viewModel).then(function(){d(!1),i.callOnModelChange.push(i.viewModel.addListener("changed",function(e){return i.tree.refresh(e,!0)}))}).done(null,a.onUnexpectedError)),i.viewModel.append(E),o.stop())},S=setInterval(function(){if(f)return window.clearInterval(S),void 0;var e=!0;if(y>0&&_>0){var t=Math.round(_/y*100);t>l&&(u.worked(t-l),l=t,e=!1)}e&&90>l&&(l++,u.worked(1)),b!==E.length&&(b=E.length,i.tree.refresh().then(function(){d(!1)}).done(null,a.onUnexpectedError))},200);this.currentRequest=this.searchServices.search(e),this.currentRequest.then(g,v,T)},t.prototype.showEmptyStage=function(){this.actionRegistry.refresh.enabled=!1,this.actionRegistry.selectOrRemove.enabled=!1,this.actionRegistry.collapseAll.enabled=!1,this.actionRegistry.clearSearchResults.enabled=!1,this.messages.hide(),this.tree.setInput(this.instantiationService.createInstance(N.SearchResult,null)).done(null,a.onUnexpectedError),this.results.show(),this.tree.onVisible()},t.prototype.onFocus=function(e,t,r){if(!(e instanceof N.Match))return n.Promise.as(!0);var i=e.parent().resource(),o=e.range();return this.telemetryService.publicLog("searchResultChosen"),this.editorService.openEditor({resource:i,options:{preserveFocus:t,selection:o}},r)},t.prototype.onUntitledFileDeleted=function(e){if(this.viewModel)for(var t=this.viewModel.matches(),n=0,r=t.length;r>n;n++)e.resource.toString()===t[n].resource().toString()&&this.viewModel.remove(t[n])},t.prototype.onFilesChanged=function(e){if(this.viewModel)for(var t=this.viewModel.matches(),n=0,r=t.length;r>n;n++)e.contains(t[n].resource(),A.FileChangeType.DELETED)&&this.viewModel.remove(t[n])},t.prototype.getSelection=function(){return new q.StructuredSelection(this.tree.getSelection())},t.prototype.getActions=function(){return[this.actionRegistry.refresh,this.actionRegistry.collapseAll,this.actionRegistry.clearSearchResults]},t.prototype.dispose=function(){this.isDisposed=!0,this.tree&&this.tree.dispose(),this.disposeModel(),e.prototype.dispose.call(this)},t.prototype.disposeModel=function(){this.viewModel&&(this.viewModel.dispose(),this.viewModel=null),o.cAll(this.callOnModelChange)},t.MAX_TEXT_RESULTS=2048,t=__decorate([__param(0,Y.ITelemetryService),__param(1,j.IEventService),__param(2,R.IWorkbenchEditorService),__param(3,z.IProgressService),__param(4,G.IMessageService),__param(5,V.IStorageService),__param(6,$.IContextViewService),__param(7,U.IInstantiationService),__param(8,B.IConfigurationService),__param(9,W.IWorkspaceContextService),__param(10,H.ISearchService),__param(11,X),__param(12,K.IKeybindingService)],t)}(L.Viewlet);t.SearchViewlet=mt});